# -*- coding: utf-8 -*-
"""
@file   tmtcc_tc_service5_event.py
@brief  PUS Service 5: Event Service
        PUS Service 17: Test Service
@author R. Mueller
@date   02.05.2020
"""
from tmtc_core.pus_tc.tmtcc_pus_tc_packer import TcQueueT
from tmtc_core.pus_tc.tmtcc_pus_tc_base import PusTelecommand
from tmtc_core.pus_tc.tmtcc_tc_service17_test import pack_service17_ping_command


def pack_service5_test_into(tc_queue: TcQueueT):
    tc_queue.appendleft(("print", "Testing Service 5"))
    # invalid subservice
    tc_queue.appendleft(("print", "Testing Service 5: Invalid subservice"))
    command = PusTelecommand(service=5, subservice=1, ssc=500)
    tc_queue.appendleft(command.pack_command_tuple())
    # disable events
    tc_queue.appendleft(("print", "Testing Service 5: Disable event"))
    command = PusTelecommand(service=5, subservice=6, ssc=500)
    tc_queue.appendleft(command.pack_command_tuple())
    # trigger event
    tc_queue.appendleft(("print", "Testing Service 5: Trigger event"))
    command = PusTelecommand(service=17, subservice=128, ssc=510)
    tc_queue.appendleft(command.pack_command_tuple())
    # enable event
    tc_queue.appendleft(("print", "Testing Service 5: Enable event"))
    command = PusTelecommand(service=5, subservice=5, ssc=520)
    tc_queue.appendleft(command.pack_command_tuple())
    # trigger event
    tc_queue.appendleft(("print", "Testing Service 5: Trigger another event"))
    command = PusTelecommand(service=17, subservice=128, ssc=530)
    tc_queue.appendleft(command.pack_command_tuple())
    tc_queue.appendleft(("export", "log/tmtc_log_service5.txt"))


